<?php
/**********************************************************************************
* Subs-ROAM.php is subs for ROAM @ Re-Organized Admin Menu mod
***********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE, 
**********************************************************************************/
if (!defined('SMF')) 
	die('Hacking attempt...');

/**********************************************************************************
* The hook for ROAM @ Re-Organized Admin Menu mod
**********************************************************************************/

function ROAM_Buttons(&$admin_areas)
{
	global $txt, $scripturl, $context, $modSettings, $settings;
	
	// Load the ROAM language
	loadLanguage('ROAM');

	if (!empty($modSettings['enable_roam'])) {

		// Pull Reports To Main Section
		if (isset($admin_areas['maintenance']['areas']['reports']))
			$admin_areas['forum']['areas']['reports'] = $admin_areas['maintenance']['areas']['reports'];
		unset($admin_areas['maintenance']['areas']['reports']);

		// Create Modification Section
		$modification = array(
			'modification' => array(
				'title' => $txt['roam_mod_title'],
				'permission' => array('admin_forum'),
				'areas' => array(
					'corefeatures' => $admin_areas['config']['areas']['corefeatures'],
					'packages' => $admin_areas['forum']['areas']['packages'],
					'modsettings' => $admin_areas['config']['areas']['modsettings'],
					'mailque' => $admin_areas['maintenance']['areas']['mailqueue'],
					'sengines' => $admin_areas['members']['areas']['sengines'],
				)
			)
		);

		// Then we make two pieces, and insert ours in between the two.
		$first = array_slice($admin_areas, 0, 1);
		$second = array_slice($admin_areas, 1);
		$admin_areas = array_merge($first, $modification, $second);
		
		// Now Unset The One That We Moved
		unset($admin_areas['forum']['areas']['packages']);
		unset($admin_areas['config']['areas']['corefeatures']);
		unset($admin_areas['config']['areas']['modsettings']);
		unset($admin_areas['maintenance']['areas']['mailqueue']);
		unset($admin_areas['members']['areas']['sengines']);

		// Create Theme Section
		$theme = array(
			'theme' => array(
				'title' => $txt['roam_theme_title'],
				'permission' => array('admin_forum'),
				'areas' => array(
					'current_theme' => $admin_areas['config']['areas']['current_theme'],
					'theme' => $admin_areas['config']['areas']['theme'],
					'smileys' => $admin_areas['layout']['areas']['smileys'],
					'manageattachments' => $admin_areas['layout']['areas']['manageattachments'],
				)
			)
		);
		
		// Then we make two pieces, and insert ours in between the two.
		$third = array_slice($admin_areas, 0, 3);
		$fourth = array_slice($admin_areas, 3);
		$admin_areas = array_merge($third, $theme, $fourth);

		// Now Unset The One That We Moved
		unset($admin_areas['config']['areas']['current_theme']);
		unset($admin_areas['config']['areas']['theme']);
		unset($admin_areas['layout']['areas']['smileys']);
		unset($admin_areas['layout']['areas']['manageattachments']);

		// Pull Reports To Main Section
		if (isset($admin_areas['members']['areas']['permissions']))
			$admin_areas['maintenance']['areas']['permissions'] = $admin_areas['members']['areas']['permissions'];
		unset($admin_areas['members']['areas']['permissions']);
	}
}

function ROAM_Settings(&$config_vars)
{
	global $txt, $scripturl, $context, $modSettings, $settings;
	
	// Load the ROAM language
	loadLanguage('ROAM');

	$roam = array(
			// Add Yellow Settings
			'',
			array('check', 'enable_roam'),
	);
	// Insert after all available slice.
	$first = array_slice($config_vars, 0);
	$config_vars = array_merge($first, $roam);
}
?>